
(*@ function rec append_last (x: 'a) (l: 'a list) : 'a list =
      match l with
      | [] -> x :: []
      | y :: r -> y :: append_last x r *)

type 'a t
(*@ mutable model contents : 'a list *)

val create : unit -> 'a t
(*@ t = create ()
      ensures t.contents = [] *)

val is_empty : 'a t -> bool
(*@ b = is_empty t
      ensures b = if t.contents = [] then true
                  else false *)

val push : 'a -> 'a t -> unit
(*@ push x t
      modifies t.contents
      ensures t.contents = append_last x (old t.contents) *)

exception Empty

val pop : 'a t -> 'a
(*@ x = pop t
      modifies t.contents
      ensures  t.contents = if old t.contents = []
                            then []
                            else List.tl (old t.contents)
      ensures  if old t.contents = [] then false
               else x = List.hd (old t.contents)
      raises Empty -> old t.contents = [] = t.contents *)

(*
 * Local Variables:
 * compile-command: "ortac qcheck-stm lib.mli "create ()" "char t" > main.ml"
 * End:
 *)
